﻿
/*
* infoGet 扩展 
* Date  : 2020-02-19
* author:lith
 

 
*/


/*

  <info-get ig-class='Select' ig-id='Select' ig-param='{value:"Text"}' />


    (1).初始化属性
    ig_param:
    {
       options: ['option1','option2','option3'] ,  // or [{id:'1',text:'option1'}]
       value:'option2',     // optional
       width:220,           // optional, default:220
       height:null,         // optional, default:null
       disabled:false,      // optional, default:false
       mode:'edit|show',    // optional, default:edit
    }


     (2).对象属性 
     [属性]
     (x.0)  igId,igParam,disabled

     [方法]
     (x.1)  event_Set(eventName, funcEvent) 
     (x.2)  event_Add(eventName, funcEvent)

     (x.3)  init() 
     (x.4)  getValue(),setValue(value)  
     (x.5)  enable(),disable() 
    
     (x.8)  resize(width, height)
     (x.9)  setMode(mode) 
 

   (3).事件
     (x.1)  onSetValue :  function (value) { };
            在值变更时触发


   (4).Demo

 */

; if (typeof (infoGet) == 'undefined') infoGet = {};
if (!infoGet.widget) infoGet.widget = {};

; (function (scope) {

    var className = 'Select';

    
 

    class Widget {

        jeElem;
        jeShow;
 
        ig_attr;
        ig_param;

        mode = 'edit';
        disabled = false;

        options; // Option[]
        constructor(jeElem, ig_attr) {
            this.jeElem = jeElem;
            this.ig_attr = ig_attr;
            this.ig_param = ig_attr?.ig_param || {};

            let options = this.ig_param.options || [];

            this.options = options.map(option => {
                if (typeof (option) === 'object') return option;
                return { text: option, id: option };
            });

            this.init();
        }


        init() {
            this.jeElem.addClass('ig_Select');

            // #1 width height
            this.jeElem.width(this.ig_param.width || 220);
            if ('height' in this.ig_param) {
                this.jeElem.height(this.ig_param.height);
            }

            // #2 init element
            this.jeElem.select2({
                data: this.options,
                allowClear: true,
            });
 

            // #3 disabled
            if (this.ig_param.disabled === true) {
                this.disable();
            }

            // #4 mode
            if ('mode' in this.ig_param) {
                this.setMode(this.ig_param.mode);
            }

            // #5 value
            if ('value' in this.ig_param) {
                this.setValue(this.ig_param.value);
            }
      
        }


        //mode   'show'  'edit'(default) 
        setMode(mode) {
            let self = this

            if (self.mode == mode) return;

            var value = self.getValue();

            self.mode = mode;
            if (self.mode == 'edit') {
                this.jeElem.show();
                this.jeElem.nextAll('span.select2-container').show();
                this.jeShow?.hide();
            } else {
                if (!this.jeShow) {
                    this.jeShow = $('<span class="ig_mode_show ig_Select"  /> ');
                    this.jeElem.after(this.jeShow);
                }
                this.jeElem.hide();
                this.jeElem.nextAll('span.select2-container').hide();
                this.jeShow.show();
            }

            self.setValue(value);
        };


        setValue(value) {
            if (this.mode == 'edit') {
                this.jeElem.val(value);
                this.jeElem.trigger('change');
            } else {
                this.jeShow.text(value);
            }   
        }

        getValue() {
            if (this.mode == 'edit') {
                return this.jeElem.val();
            } else {
                return this.jeShow.text();
            }
        }

        enable() {
            this.disabled = false;
            this.jeElem.select2({ disabled: false });
        }

        disable() {
            this.disabled = true;
            this.jeElem.select2({ disabled: true });
        }

    }
     

    //构建html控件字符串
    Widget.buildHtml = function (ig_attr) {        

        var html = '<select  ';      


        //html += ' style="width:' + width + 'px;height:' + height + 'px;" ';
        var igParam = ig_attr['ig_param'];
        if (igParam) {
            var style = '';
            if (igParam.width) style += 'width:' + igParam.width + 'px;';

            if (igParam.height) style += 'height:' + igParam.height + 'px;';

            if (style) html += ' style="' + style + '"';
        }
       
        

        html += infoGet.getHtmlCtrl_attr(ig_attr);
        html += ' />';
        return html;

    };


 
    Widget.className = className;
    scope[className] = Widget;

 

})(infoGet.widget);